// Hledej.cpp : implementation file
//

#include "stdafx.h"
#include "Mapa.h"
#include "Hledej.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHledej dialog


CHledej::CHledej(CWnd* pParent /*=NULL*/)
	: CDialog(CHledej::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHledej)
	m_strOdkud = _T("");
	m_intMode = 0;
	m_strKam = _T("");
	m_strPres = _T("");
	//}}AFX_DATA_INIT
}


void CHledej::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHledej)
	DDX_Control(pDX, IDC_COMBO2, m_ctlPres);
	DDX_Control(pDX, IDC_COMBO1, m_ctlKam);
	DDX_Control(pDX, IDC_COMBO3, m_ctlOdkud);
	DDX_CBString(pDX, IDC_COMBO3, m_strOdkud);
	DDX_Radio(pDX, IDC_RADIO1, m_intMode);
	DDX_CBString(pDX, IDC_COMBO1, m_strKam);
	DDX_CBString(pDX, IDC_COMBO2, m_strPres);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHledej, CDialog)
	//{{AFX_MSG_MAP(CHledej)
	ON_BN_CLICKED(IDOK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHledej message handlers

BOOL CHledej::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for(int index=0;index<pDoc->m_aMesta.GetSize();index++) {
		m_ctlOdkud.AddString(pDoc->m_aMesta[index].name);
		m_ctlKam.AddString(pDoc->m_aMesta[index].name);
		m_ctlPres.AddString(pDoc->m_aMesta[index].name);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHledej::OnOk() 
{
	UpdateData();

	unsigned odkud,kam,pres;
	if (!pDoc->m_mapMesta.Lookup(m_strOdkud,odkud)) {
		CString str;
		str.Format("Zadan msto %s v kolonce \"odkud\"neexistuje!",m_strOdkud);
		AfxMessageBox(str,MB_OK|MB_ICONSTOP);
		return;		
	}
	if (!pDoc->m_mapMesta.Lookup(m_strKam,kam)) {
		CString str;
		str.Format("Zadan msto %s v kolonce \"kam\"neexistuje!",m_strKam);
		AfxMessageBox(str,MB_OK|MB_ICONSTOP);
		return;		
	}
	if (m_strPres.IsEmpty()) pres=-1;
	else if (!pDoc->m_mapMesta.Lookup(m_strPres,pres)) {
		CString str;
		str.Format("Zadan msto %s v kolonce \"pes\"neexistuje!",m_strPres);
		AfxMessageBox(str,MB_OK|MB_ICONSTOP);
		return;		
	}

	pDoc->m_bAktCesta=false;
	pDoc->m_aAktCesta.RemoveAll();

	if (pres==-1) {
		if (!NajdiCestu(odkud,kam)) {
			CString str;
			str.Format("Cesta z msta \"%s\" do msta \"%\" nebyla nalezena!",m_strOdkud,m_strKam);
			AfxMessageBox(str,MB_OK|MB_ICONSTOP);
			return;
		}
		EndDialog(IDOK);
	}
	else {
		if (!NajdiCestu(odkud,pres)) {
			CString str;
			str.Format("Cesta z msta \"%s\" do msta \"%s\" nebyla nalezena!",m_strOdkud,m_strPres);
			AfxMessageBox(str,MB_OK|MB_ICONSTOP);
			return;
		}
		pDoc->m_aAktCesta.RemoveAt(pDoc->m_aAktCesta.GetUpperBound());
		if (!NajdiCestu(pres,kam)) {
			CString str;
			str.Format("Cesta z msta \"%s\" do msta \"%s\" nebyla nalezena!",m_strPres,m_strKam);
			AfxMessageBox(str,MB_OK|MB_ICONSTOP);
			pDoc->m_bAktCesta=false;
			pDoc->m_aAktCesta.RemoveAll();
			return;
		}
		EndDialog(IDOK);
	}
}

double CHledej::ZjistiDelku(int odkud, int kam)
{
	double spot;
	switch(m_intMode) {
	case 1://rychlost = cas
		return pDoc->m_aMesta[odkud].m_aCesty[kam].len * 3600. / (double)pDoc->m_aMesta[odkud].m_aCesty[kam].rychlost;
		break;
	case 2://spotreba
		pDoc->m_mapSpotreba.Lookup(pDoc->m_aMesta[odkud].m_aCesty[kam].rychlost,spot);
		return pDoc->m_aMesta[odkud].m_aCesty[kam].len * spot / 100.;
		break;
	}
	return pDoc->m_aMesta[odkud].m_aCesty[kam].len;
}

bool CHledej::NajdiCestu(int odkud, int kam)
{
	int i,N=pDoc->m_aMesta.GetSize();

	double *vz=new double[N];
	double *dj=new double[N];
	double *sp=new double[N];

	double *delky=new double[N];
	int *hotovo=new int[N];
	int *P=new int[N];

	memset(hotovo,0,sizeof(int)*N);
	for (i=0;i<N;i++) delky[i]=1e30;

	P[odkud]=odkud;
	delky[odkud]=0;
	vz[odkud]=dj[odkud]=sp[odkud]=0;
	while (!hotovo[kam]) {
		int i,next=-1;
		double next_v=1e30;

		for (i=0;i<N;i++) if (!hotovo[i] && delky[i] < next_v) {
			next_v=delky[i];
			next=i;
		}

		if (next==-1) {
			delete[] vz;
			delete[] dj;
			delete[] sp;
			delete[] delky;
			delete[] hotovo;
			delete[] P;
			return false;
		}

		hotovo[next]=1;
		for (i=0;i<pDoc->m_aMesta[next].m_aCesty.GetSize();i++) {
			int kam=pDoc->m_aMesta[next].m_aCesty[i].kam;
			double my=ZjistiDelku(next,i);

			if (!hotovo[kam] && delky[next]+my < delky[kam]) {
				delky[kam]=delky[next]+my;
				int m_iM=m_intMode;
				m_intMode=0;vz[kam]=ZjistiDelku(next,i);
				m_intMode=1;dj[kam]=ZjistiDelku(next,i);
				m_intMode=2;sp[kam]=ZjistiDelku(next,i);
				m_intMode=m_iM;
				P[kam]=next;
			}
		}
	}

	pDoc->m_bAktCesta=true;
	int iii=pDoc->m_aAktCesta.GetSize();
	i=kam;
	while(1) {
		misto m;
		m.index=i;
		m.spot=sp[i];
		m.times=dj[i];
		m.vzdal=vz[i];
		pDoc->m_aAktCesta.InsertAt(iii,m);
		if (i==P[i]) break;
		i=P[i];
	}

	delete[] vz;
	delete[] dj;
	delete[] sp;
	delete[] delky;
	delete[] hotovo;
	delete[] P;
	return true;
}

