// MapaDoc.cpp : implementation of the CMapaDoc class
//

#include "stdafx.h"
#include "Mapa.h"

#include "MapaDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapaDoc

IMPLEMENT_DYNCREATE(CMapaDoc, CDocument)

BEGIN_MESSAGE_MAP(CMapaDoc, CDocument)
	//{{AFX_MSG_MAP(CMapaDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapaDoc construction/destruction

CMapaDoc::CMapaDoc()
{
	// TODO: add one-time construction code here

}

CMapaDoc::~CMapaDoc()
{
}

BOOL CMapaDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_bAktCesta=false;
	m_mapMesta.RemoveAll();
	m_mapSpotreba.RemoveAll();
	m_aMesta.RemoveAll();
	m_aAktCesta.RemoveAll();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMapaDoc serialization

void CMapaDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMapaDoc diagnostics

#ifdef _DEBUG
void CMapaDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMapaDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapaDoc commands

void CMapaDoc::OnFileOpen() 
{
	CFileDialog fd(TRUE,"xml",0,OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,"XML soubory(*.xml)|*.xml|Vsechny soubory(*.*)|*.*||",AfxGetApp()->GetMainWnd());
	int odkud,kam;
	double spot;

	if (fd.DoModal()==IDOK) {
		CString fname=fd.GetPathName();

		FILE *fr=fopen(fname,"rb");
		if (!fr) {
			AfxMessageBox("Nemohu otevt dan soubor!",MB_OK|MB_ICONSTOP);
			return;
		}

		m_bAktCesta=false;
		m_mapMesta.RemoveAll();
		m_mapSpotreba.RemoveAll();
		m_aMesta.RemoveAll();
		m_aAktCesta.RemoveAll();

		CString tag;
		while ((tag=GetTag(fr))!="/mapa") {
			//mesta
			if (tag=="mesta") while ((tag=GetTag(fr))!="/mesta") {
				if (tag=="mesto") {
					int index=m_aMesta.GetSize();
					m_aMesta.SetSize(index+1,20);

					while ((tag=GetTag(fr))!="/mesto") {
						if (tag=="nazev") m_aMesta[index].name=GetString(fr);
						if (tag=="polohax") m_aMesta[index].x=atoi(GetString(fr));
						if (tag=="polohay") m_aMesta[index].y=atoi(GetString(fr));
					}

					m_mapMesta[m_aMesta[index].name]=index;
				}
			}

			//cesty
			if (tag=="cesty") while ((tag=GetTag(fr))!="/cesty") {
				if (tag=="cesta") {
					cesta ccc;
					unsigned int index;
					CString zaljm;

					while ((tag=GetTag(fr))!="/cesta") {
						if (tag=="z") if (!m_mapMesta.Lookup((zaljm=GetString(fr)),index)) {
							CString str;
							str.Format("Chybn msto \"%s\" v cestach mapy!",zaljm);
							AfxMessageBox(str,MB_OK|MB_ICONSTOP);
							goto error;
						}
						if (tag=="do") if (!m_mapMesta.Lookup((zaljm=GetString(fr)),ccc.kam)) {
							CString str;
							str.Format("Chybn msto \"%s\" v cestach mapy!",zaljm);
							AfxMessageBox(str,MB_OK|MB_ICONSTOP);
							goto error;
						}
						if (tag=="vzdalenost") ccc.len=atoi(GetString(fr));
						if (tag=="prumernarychlost") ccc.rychlost=atoi(GetString(fr));
					}

					m_aMesta[index].m_aCesty.Add(ccc);

					int tmp=index;
					index=ccc.kam;
					ccc.kam=tmp;
					m_aMesta[index].m_aCesty.Add(ccc);
				}
			}

			//spotreby
			if (tag=="spotreby") while ((tag=GetTag(fr))!="/spotreby") {
				if (tag=="spotreba") {
					unsigned int rychlost;
					double litru;

					while ((tag=GetTag(fr))!="/spotreba") {
						if (tag=="rychlost") rychlost=atoi(GetString(fr));
						if (tag=="litru") litru=atof(GetString(fr));
					}

					m_mapSpotreba[rychlost]=litru;
				}

			}

		}

		for (odkud=0;odkud<m_aMesta.GetSize();odkud++)
			for (kam=0;kam<m_aMesta[odkud].m_aCesty.GetSize();kam++)
				if (!m_mapSpotreba.Lookup(m_aMesta[odkud].m_aCesty[kam].rychlost,spot)) {
					CString str;
					str.Format("Chybn rychlost \"%d\" v cestach mapy!",m_aMesta[odkud].m_aCesty[kam].rychlost);
					AfxMessageBox(str,MB_OK|MB_ICONSTOP);
					goto error;
				}

		this->UpdateAllViews(0);
	}


	return;
error:
	m_bAktCesta=false;
	m_mapMesta.RemoveAll();
	m_mapSpotreba.RemoveAll();
	m_aMesta.RemoveAll();
	m_aAktCesta.RemoveAll();
}

void CMapaDoc::OnFileSave() 
{
	CFileDialog fd(FALSE,"xml",0,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"XML soubory(*.xml)|*.xml|Vsechny soubory(*.*)|*.*||",AfxGetApp()->GetMainWnd());

	double vz=0,spot=0,cas=0;
	if (fd.DoModal()==IDOK) {
		FILE *fw;
		fw=fopen(fd.GetPathName(),"wb");

		if (!fw) {
			AfxMessageBox("Nemohu otevt dan soubor!",MB_OK|MB_ICONSTOP);
			return;
		}

		fprintf(fw,"<?xml version=\"1.0\" encoding=\"windows-1250\"?>\r\n<cesta>\r\n");
		fprintf(fw,"  <z>%s</z>\r\n",m_aMesta[m_aAktCesta[0].index].name);
		fprintf(fw,"  <do>%s</do>\r\n",m_aMesta[m_aAktCesta[m_aAktCesta.GetUpperBound()].index].name);

		for (int i=1;i<m_aAktCesta.GetUpperBound();i++) {
			fprintf(fw,"  <pres>%s</pres>\r\n",m_aMesta[m_aAktCesta[i].index].name);
			vz+=m_aAktCesta[i].vzdal;
			spot+=m_aAktCesta[i].spot;
			cas+=m_aAktCesta[i].times;
		}
		vz+=m_aAktCesta[i].vzdal;
		spot+=m_aAktCesta[i].spot;
		cas+=m_aAktCesta[i].times;
		fprintf(fw,"  <vzdalenost>%d</vzdalenost>\r\n",(int)vz);
		fprintf(fw,"  <dobaJizdy>%d:%d</dobaJizdy>\r\n",(int)(cas/3600),((int)(cas/60))%60);
		fprintf(fw,"  <spotreba>%g</spotreba>\r\n",spot);
		fprintf(fw,"</cesta>");

		fclose(fw);
	}	
}

CString CMapaDoc::GetTag(FILE *fr)
{
	CString tag;
	unsigned char c;

	while (fgetc(fr)!='<') ;
	while ((c=fgetc(fr))!='>') tag+=c;
	tag.MakeLower();
	return tag;
}

CString CMapaDoc::GetString(FILE *fr)
{
	CString str;
	unsigned char c;

	while ((c=fgetc(fr))!='<') str+=c;
	while ((c=fgetc(fr))!='>') ;

	return str;
}

void CMapaDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bAktCesta);	
}
