// MapaView.cpp : implementation of the CMapaView class
//

#include "stdafx.h"
#include "Mapa.h"

#include "MapaDoc.h"
#include "MapaView.h"
#include "ZobrMapy.h"
#include "GetCity.h"
#include "Cesty.h"
#include "Hledej.h"
#include "AktCesta.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapaView

IMPLEMENT_DYNCREATE(CMapaView, CScrollView)

BEGIN_MESSAGE_MAP(CMapaView, CScrollView)
	//{{AFX_MSG_MAP(CMapaView)
	ON_COMMAND(IDM_ZOBRMAPY, OnZobrmapy)
	ON_COMMAND(IDM_CESTY, OnCesty)
	ON_COMMAND(IDM_FIND, OnFind)
	ON_COMMAND(IDM_CANCEL_AKT, OnCancelAkt)
	ON_UPDATE_COMMAND_UI(IDM_CANCEL_AKT, OnUpdateCancelAkt)
	ON_COMMAND(IDM_LIST_ACT, OnListAct)
	ON_UPDATE_COMMAND_UI(IDM_LIST_ACT, OnUpdateListAct)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapaView construction/destruction

CMapaView::CMapaView() : m_bCesty(true),m_intZoom(5000),m_bBarvy(true),m_bDelky(true),
	v60(RGB(0,0,0)),v90(RGB(0,0,255)),v130(RGB(255,0,0))
{
	// TODO: add construction code here

}

CMapaView::~CMapaView()
{
}

BOOL CMapaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMapaView drawing

void CMapaView::OnDraw(CDC* pDC)
{
	CMapaDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (pDoc->m_aMesta.GetSize()<=0) return;

	int left,right,top,bottom;
	left=right=pDoc->m_aMesta[0].x;
	top=bottom=pDoc->m_aMesta[0].y;

	for(int index=1;index<pDoc->m_aMesta.GetSize();index++) {
		if (pDoc->m_aMesta[index].x<left) left=pDoc->m_aMesta[index].x;
		if (pDoc->m_aMesta[index].x>right) right=pDoc->m_aMesta[index].x;
		if (pDoc->m_aMesta[index].y<top) top=pDoc->m_aMesta[index].y;
		if (pDoc->m_aMesta[index].y>bottom) bottom=pDoc->m_aMesta[index].y;
	}

	CSize sizeTotal;
	sizeTotal.cx = (long) ((right - left)*m_intZoom/1000. + 50);
	sizeTotal.cy = (long) ((bottom - top)*m_intZoom/1000. + 50);
	SetScrollSizes(MM_TEXT, sizeTotal);

	if (m_bCesty) {
		for(index=0;index<pDoc->m_aMesta.GetSize();index++) {
			int sx=(int)(25 + (pDoc->m_aMesta[index].x-left)*m_intZoom/1000.);
			int sy=(int)(25 + (pDoc->m_aMesta[index].y-top)*m_intZoom/1000.);

			for(int nindex=0;nindex<pDoc->m_aMesta[index].m_aCesty.GetSize();nindex++) {
				int kam=pDoc->m_aMesta[index].m_aCesty[nindex].kam;

				int ksx=(int)(25 + (pDoc->m_aMesta[kam].x-left)*m_intZoom/1000.);
				int ksy=(int)(25 + (pDoc->m_aMesta[kam].y-top)*m_intZoom/1000.);
				
				if (m_bBarvy) {
					COLORREF col;
					unsigned rychlost=pDoc->m_aMesta[index].m_aCesty[nindex].rychlost;
					if (rychlost<=60) col=v60;
					else if (rychlost<=90) col=RGB((rychlost-60)/30.*(GetRValue(v90)-GetRValue(v60)),
						(rychlost-60)/30.*(GetGValue(v90)-GetGValue(v60)),(rychlost-60)/30.*(GetBValue(v90)-GetBValue(v60)));
					else if (rychlost<130) col=RGB((rychlost-90)/40.*(GetRValue(v130)-GetRValue(v90)),
						(rychlost-90)/40.*(GetGValue(v130)-GetGValue(v90)),(rychlost-90)/40.*(GetBValue(v130)-GetBValue(v90)));
					else col=v130;

					if (pDoc->m_bAktCesta) {
						int found=0;
						for (int ii=0;ii+1<pDoc->m_aAktCesta.GetSize();ii++) {
							if (pDoc->m_aAktCesta[ii].index==index && pDoc->m_aAktCesta[ii+1].index==kam) found=1;
							if (pDoc->m_aAktCesta[ii].index==kam && pDoc->m_aAktCesta[ii+1].index==index) found=1;
						}
						if (found)
							col=RGB(0,255,0);
					}

					CPen cclr(PS_SOLID,1,col);

					pDC->SelectObject(&cclr);
					pDC->MoveTo(sx,sy);
					pDC->LineTo(ksx,ksy);
					if (m_bDelky) {
						CString delka;
						delka.Format("%d",pDoc->m_aMesta[index].m_aCesty[nindex].len);
						pDC->SetTextColor(col);
						pDC->DrawText(delka,CRect((sx+ksx)/2,(sy+ksy)/2-8,(sx+ksx)/2,(sy+ksy)/2-8),DT_CENTER|DT_VCENTER|DT_NOCLIP);
						pDC->SetTextColor(RGB(0,0,0));
					}
					pDC->SelectStockObject(BLACK_PEN);
				} else {
					pDC->MoveTo(sx,sy);
					pDC->LineTo(ksx,ksy);
				}
			}
		}
	}

	for(index=0;index<pDoc->m_aMesta.GetSize();index++) {
		int sx=(int)(25 + (pDoc->m_aMesta[index].x-left)*m_intZoom/1000.);
		int sy=(int)(25 + (pDoc->m_aMesta[index].y-top)*m_intZoom/1000.);

		pDC->Ellipse(sx-5,sy-5,sx+5,sy+5);
	}

	for(index=0;index<pDoc->m_aMesta.GetSize();index++) {
		int sx=(int)(25 + (pDoc->m_aMesta[index].x-left)*m_intZoom/1000.);
		int sy=(int)(25 + (pDoc->m_aMesta[index].y-top)*m_intZoom/1000.);

		pDC->DrawText(pDoc->m_aMesta[index].name,CRect(sx,sy-25,sx,sy-25),DT_CENTER|DT_VCENTER|DT_NOCLIP);
	}
}

void CMapaView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CMapaView diagnostics

#ifdef _DEBUG
void CMapaView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMapaView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMapaDoc* CMapaView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapaDoc)));
	return (CMapaDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapaView message handlers

void CMapaView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	Invalidate();
}

void CMapaView::OnZobrmapy() 
{
	CZobrMapy dlg(m_intZoom);

	dlg.m_bCesty=m_bCesty;
	dlg.m_bBarvy=m_bBarvy;
	dlg.m_bDelky=m_bDelky;
	dlg.v60=v60;
	dlg.v90=v90;
	dlg.v130=v130;
	if (dlg.DoModal()==IDOK) {
		m_bCesty=dlg.m_bCesty!=0;
		m_bBarvy=dlg.m_bBarvy!=0;
		m_bDelky=dlg.m_bDelky!=0;
		m_intZoom=dlg.zoom;
		v60=dlg.v60;
		v90=dlg.v90;
		v130=dlg.v130;

		Invalidate();
	}
}

void CMapaView::OnCesty() 
{
	CGetCity dlg;

	dlg.pDoc=GetDocument();
	if (dlg.DoModal()==IDOK) {
		if (!DoesCitiExist(dlg.m_strCity)) {
			CString str;
			str.Format("Zadan msto %s neexistuje!",dlg.m_strCity);
			AfxMessageBox(str,MB_OK|MB_ICONSTOP);
			return;
		}

		CCesty cesty;
		cesty.pDoc=GetDocument();
		cesty.pDoc->m_mapMesta.Lookup(dlg.m_strCity,cesty.cindex);

		cesty.DoModal();
	}
}

bool CMapaView::DoesCitiExist(CString name)
{
	unsigned index;

	return ((CMapaDoc*)GetDocument())->m_mapMesta.Lookup(name,index)!=0;
}

void CMapaView::OnFind() 
{
	CHledej dlg;

	dlg.pDoc=GetDocument();
	if (dlg.DoModal()==IDOK) {
		Invalidate();

		AktCesta akt;
		akt.pDoc=GetDocument();
		akt.DoModal();
	}
}

void CMapaView::OnCancelAkt() 
{
	((CMapaDoc*)GetDocument())->m_bAktCesta=false;
}

void CMapaView::OnUpdateCancelAkt(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(((CMapaDoc*)GetDocument())->m_bAktCesta);	
}

void CMapaView::OnListAct() 
{
		AktCesta akt;
		akt.pDoc=GetDocument();
		akt.DoModal();
}

void CMapaView::OnUpdateListAct(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(((CMapaDoc*)GetDocument())->m_bAktCesta);	
}
